package lab18;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import org.w3c.dom.Element;

import java.io.File;
import java.text.DecimalFormat;
import java.util.*;
 
public class Lab18 {

	public static void main(String argv[]) {
 
	  try {
		File xmlfile = new File("lab18Files/store2.xml");
		DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
		Document doc = dBuilder.parse(xmlfile);
		doc.getDocumentElement().normalize();
 
		NodeList customerList = doc.getElementsByTagName("customer");
		NodeList itemList = doc.getElementsByTagName("item");
 
		for (int i = 0; i < customerList.getLength(); i++) {
			  Node cNode = customerList.item(i);
		      Element cElement = (Element) cNode;
			  NodeList nameNodeList = cElement.getElementsByTagName("name");
			  Node nameNode = nameNodeList.item(0);
			  Element nameElement = (Element) nameNode;
			  
			  System.out.println("Customer ID: " + cElement.getAttribute("cid"));
			  System.out.println("Title: " + nameElement.getAttribute("title"));
		      System.out.println("First Name: " + getElementValue("first", cElement));
			  NodeList middleNodeList = cElement.getElementsByTagName("middle");
			  if(middleNodeList.getLength() > 0) {
				  System.out.print("Middle Name(s):");
			  	  for(int j = 0; j < middleNodeList.getLength(); j++){
			  		  Node middleNode = middleNodeList.item(j);
			  		  Element middleElement = (Element) middleNode;
			  		  NodeList mdl = middleElement.getChildNodes();
			  		  System.out.print(" " + mdl.item(0).getNodeValue());
			  	  }
			  	  System.out.println();
			  }
			  
	          System.out.println("Last Name: " + getElementValue("last", cElement));
		  	  NodeList purchaseNodeList = cElement.getElementsByTagName("purchase");
			  List<String> itemVector = new ArrayList<String>();
			  List<Integer> qtyVector = new ArrayList<Integer>();
			  List<Float> priceVector = new ArrayList<Float>();
			  for(int j = 0; j < purchaseNodeList.getLength(); j++){
				  
				  Element purchElement = (Element) purchaseNodeList.item(j);
				  String items = purchElement.getAttribute("items");
				  String qty = purchElement.getAttribute("qty");
				  
				  StringTokenizer itemst = new StringTokenizer(items, " ");
				  while (itemst.hasMoreTokens()) 
					  itemVector.add((String) itemst.nextToken());
				  
				  StringTokenizer qtyst = new StringTokenizer(qty, " ");
				  while (qtyst.hasMoreTokens()) 
					  qtyVector.add(new Integer(qtyst.nextToken()));
				  
			  }
			  for(int j = 0; j < itemVector.size(); j++){
				  String curItem = (String)itemVector.get(j);
				  for(int k = 0; k < itemList.getLength(); k++){
					  Node itemNode = itemList.item(k);
					  Element itemElement = (Element) itemNode;
					  String itemNo = itemElement.getAttribute("item_no");
					  
					  if(itemNo.equals(curItem))
						  priceVector.add(new Float(getElementValue("price", itemElement)));
				  }
			  }
			  float total_price = 0.0f;
			  for(int l = 0; l < qtyVector.size(); l++)
				  total_price += ((Integer)qtyVector.get(l)).intValue() * ((Float)priceVector.get(l)).floatValue();
				  
			  DecimalFormat df = new DecimalFormat();
              df.setMaximumFractionDigits(2);
			  System.out.println("Total:  " + df.format(total_price) );
		  	  System.out.println();			  
		}
	  	} catch (Exception e) {
	  		e.printStackTrace();
	  	}
  }
    
  private static String getElementValue(String s1, Element element) {
	NodeList nlList = element.getElementsByTagName(s1).item(0).getChildNodes();
    Node nValue = nlList.item(0);
	return nValue.getNodeValue();
  }
}